package LIDS.Server.Database;

import LIDS.Server.Exceptions.UserAlreadyExistsException;
import LIDS.Server.System.SessionManager;
import LIDS.Server.System.User;

public class DBAccessor {
	private static Database myDB = new Database(); 
	
	public static void connect(){
		myDB.connect();
	}
	
	public static User add(User aUser)throws UserAlreadyExistsException{
		return myDB.add(aUser);
	}
	
	public static boolean isUserPresent(String aUsername){
		return myDB.isUserPresent(aUsername);
	}
	
	public static User remove(String aUserName){
		return myDB.remove(aUserName);
	}

	public static User retrieve(String aUserName, String aPassword, boolean passCheck) {
		return myDB.retrieve(aUserName, aPassword, passCheck);
	}
	
	public static void provisionClearance(String aUsername, int newLevel){
		if(SessionManager.getCurrentUser().getClearanceLevel() >= newLevel){
			myDB.provisionClearance(aUsername, newLevel);
		}else{
			SessionManager.setErrorBuffer("Action could not be performed, cannot give out a clearance level higher than your own.");
		}
	}
	
	public static void disconnect(){
		myDB.disconnect();
	}
}
