package LIDS.Server.GUI;

import java.util.Observable;
import java.util.Observer;

import javax.swing.JFrame;

import LIDS.Server.System.SocketThreadHandler;
import LIDS.Server.System.User;

//swapping between perspectives like a revolving hallway in MIST

public class GUIBase extends JFrame implements Observer{

	private static final long serialVersionUID = 1L;
	
	private int width = 1024;
	private int height = 568;
	private BatPerspective bat = null;
	private Perspective currentPerspective = new NullPerspective(); 
	public GUIBase(){
		setTitle("Dwelling Security Interface");
		setSize(1024, 568);
		setResizable(false);
		//currentPerspective = new NullPerspective();
		//bat = new BatPerspective();
		//bat.triggered();
		//currentPerspective = bat;
		currentPerspective.activate();
		setContentPane(currentPerspective);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
		//bat = new BatPerspective();
		//add(bat);
		//SocketThreadHandler.dataObserver(this);
	}
	
	public Perspective getCurrentPerspective(){
		return currentPerspective;
	}
	
	public void setCurrentPerspective(Perspective aPerspective){ //This MUST be used so that the GUIBase is observing the perspective, 
																 //otherwise perspective switches will not occur.
		currentPerspective = aPerspective;
		currentPerspective.addObserver(this);
	}
	
	public void updateUI(User aUser){
		if(aUser.getClearanceLevel() >= 0){
			((Perspective) getContentPane()).deactivate();
			setCurrentPerspective(new DefaultPerspective(this));
			setContentPane(currentPerspective);
			
			((Perspective) getContentPane()).alterForClearance(aUser.getClearanceLevel());
			return;
		}
		((Perspective) getContentPane()).clearAllFields();
	}
	
	public void updateUI(Perspective aPerspective){
		((Perspective) getContentPane()).deactivate();
		
		setContentPane(aPerspective);
		setCurrentPerspective(aPerspective);
		((Perspective) getContentPane()).activate();
	}


	public void showBatSignal() {
		//bat.triggered();
	}

	@Override
	public void update(Observable arg0, Object arg1) {
		updateUI(getCurrentPerspective());
	}
	
}
