package LIDS.Server.GUI;

import java.util.Observable;
import java.util.Vector;
import java.util.Observer;

import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;

import LIDS.Server.System.LogHandler;
import net.miginfocom.swing.MigLayout;

public class LogPerspective extends Perspective implements Observer{

	private static final long serialVersionUID = 4802774609138302926L;
	private JPanel innerPanel = null;	
	
	public LogPerspective(final GUIBase aBase, Vector<String> logs, int width, int height){
		setLayout(new MigLayout());
		innerPanel = new JPanel(new MigLayout());
		setUpLogTable(logs);
		add(innerPanel, "width 1024, wrap");
		JButton tba = new BackButton("Back", aBase);
		add(tba);	
	}

	public void setUpLogTable(Vector<String> logs){//TODO very wasteful of resources should just append new data
		String columnNames[] = {"System Logs"};
		NonEditableDefaultTableModel logModel = new NonEditableDefaultTableModel(columnNames, logs.size());
		JTable logtable  = new JTable(logModel);
		for(int i = logs.size() - 1; i >= 0; i--){
			logtable.setValueAt(logs.get(i), i, 0);
		}
		logtable.setFillsViewportHeight(true);
		logtable.getTableHeader().getColumnModel()
			.getColumn(0).setHeaderValue("System Logs");
		JScrollPane pane = new JScrollPane(logtable);
		innerPanel.add(pane, "width 1024");
		refreshPanel(pane);
	}
	
	@Override
	public void update(Observable o, Object arg) {//still broken
		innerPanel.removeAll();
		setUpLogTable(LogHandler.importLogFile());
		refreshPanel(innerPanel);
		setChanged();
	}
	
}
