package LIDS.Server.GUI;

import java.util.List;
import java.util.Observable;
import java.util.Observer;
import java.util.ArrayList;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.text.JTextComponent;

public class Perspective extends JPanel{
	
	private static final long serialVersionUID = 1L;
	protected int viewPermission = -1;
	protected List<JTextComponent> textComps = new ArrayList<JTextComponent>();
	private Observable observableObject = new Observable();
	public boolean accessGranted(int userClearanceLevel){
		if(userClearanceLevel >= viewPermission){ return true; }
		return false;
	}
	
	public void activate(){
		setVisible(true);
	}
	
	public void deactivate(){
		setVisible(false);
		observableObject.deleteObservers();
	}
	
	public void clearAllFields(){
		for(JTextComponent comp : textComps){
			String className = comp.getClass().getName();
			if(className.contains("JText") || className.contains("JPass")){
				comp.setText("");
			}
		}
	}
	
	public void refreshPanel(JComponent aPanel){
		aPanel.setVisible(false);
		aPanel.setVisible(true);
	}
	
	public void setChanged(){
		observableObject.hasChanged();
		observableObject.notifyObservers();
	}
	
	public void addObserver(Observer anObserver){
		observableObject.addObserver(anObserver);
	}
	
	public void alterForClearance(int level){
		//TODO implement
	}
}
