package LIDS.Server.GUI;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;

import LIDS.Server.System.SessionManager;

import net.miginfocom.swing.MigLayout;


public class ProvisionUserPerspective extends Perspective {

	private static final long serialVersionUID = 5011094376828812498L;

	public ProvisionUserPerspective(final GUIBase aBase){
		if(SessionManager.getCurrentUser().getClearanceLevel() >= 2){
			setLayout(new MigLayout()); 
			JComponent tba = new BackButton("Back", aBase);
			add(tba, "wrap 15mm");
			tba = new JLabel("Username");
			add(tba, "gapleft 95mm");
			final JTextField username = new JTextField();
			username.setPreferredSize(new Dimension(200, 25));
			add(username, "span 4, gapleft 10mm, wrap 10mm");
			tba = new JLabel("Password");
			add(tba, "gapleft 95mm");
			final JTextField password = new JTextField();
			password.setPreferredSize(new Dimension(200, 25));
			add(password, "span 4, gapleft 10mm, wrap 10mm");
			tba = new JButton("Add");
			((JButton) tba).addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					SessionManager.addUser(username.getText(), password.getText());//add MORE
					aBase.updateUI(SessionManager.getCurrentUser());
				}
				
			});
			add(tba, "gapleft 115mm, span 4");
			tba = new JButton("Remove");
			((JButton) tba).addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					SessionManager.removeUser(username.getText());//add MORE
					aBase.updateUI(SessionManager.getCurrentUser());
				}
				
			});
			add(tba, "gapleft 10mm, wrap");
		}else{
			add(new PermissionDeniedPerspective(aBase));
		}
	}
}
