package LIDS.Server.NetworkEvents;

import LIDS.Server.NetworkEvents.ArmSystemEvent;
import LIDS.Server.NetworkEvents.GetEvent;
import LIDS.Server.NetworkEvents.NetworkEvent;
import LIDS.Server.NetworkEvents.NullEvent;
import LIDS.Server.NetworkEvents.NumberRequisitionEvent;
import LIDS.Server.NetworkEvents.PostEvent;
import LIDS.Server.NetworkEvents.SensorCountEvent;
import LIDS.Server.NetworkEvents.SensorUpdateEvent;
import LIDS.Server.NetworkEvents.ServeFileEvent;
import LIDS.Server.NetworkEvents.SessionLoginEvent;
import java.util.TreeMap;

public class EventTable {
    private TreeMap<String, NetworkEvent> networkEvents = new TreeMap();
    private static EventTable theNetworkTable = null;

    public static void initializeNetworkTable() {
        theNetworkTable = new EventTable();
        new ServeFileEvent("serveFile");
        new NumberRequisitionEvent("numReq");
        new SessionLoginEvent("process");
        new GetEvent("GET");
        new PostEvent("POST");
        new NullEvent("");
        new SensorRelayEvent("sensorReq");
        new SensorCountEvent("sensorCount");
        new SensorUpdateEvent("update");
        new ArmSystemEvent("armSystem");
        new SensorIsArmedEvent("isArmed");
        new SensorTrippedWhileArmedEvent("isTriggered");
        new NetworkArmEvent("networkArm");
    }

    public static EventTable getTable() {
        return theNetworkTable;
    }

    public void addEvent(String eventName, NetworkEvent aNetworkEvent) {
        this.getEvents().put(eventName, aNetworkEvent);
    }

    public NetworkEvent getEvent(String eventName) {
        return this.getEvents().get(eventName);
    }

    public TreeMap<String, NetworkEvent> getEvents() {
        return this.networkEvents;
    }
}