package LIDS.Server.NetworkEvents;

import LIDS.Server.System.Sensor;
import LIDS.Server.System.SessionManager;
import LIDS.Server.System.User;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.security.SecureRandom;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

public class NumberRequisitionEvent implements NetworkEvent
{
  public NumberRequisitionEvent(String eventName)
  {
    EventTable.getTable().addEvent(eventName, this);
  }
  
  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream)
  {
    JsonObject aJsonObject = JsonWrapper.createJObject(eventData);
    String username = aJsonObject.getString("username");
    User heldUser = SessionManager.getHeldUser(username);
    if (!SessionManager.isUserPresent(username)) {
      int temp = 0;
      temp--;
      aFileNode.setProccessResults(String.valueOf(temp));
      return;
    }
    heldUser.addNumber(String.valueOf(SessionManager.getNumberGenerator().nextInt(999999999)));
    aFileNode.setProccessResults(heldUser.getNumber());
    try {
      JsonObject aResponseObject = JsonWrapper.getObjectBuilder()
        .add("number", heldUser.getNumber()).build();
      aWriteStream.write(aResponseObject.toString().getBytes());
      aWriteStream.flush();
    }
    catch (IOException e) {
      e.printStackTrace();
    }
  }
  
  public void execute(JsonObject jObject, Sensor aSensor, BufferedOutputStream aBufferedOutputStream) {}
}