package LIDS.Server.NetworkEvents;

import java.io.BufferedOutputStream;

public class PostEvent extends HttpRequestEvent implements NetworkEvent
{
  public PostEvent(String eventName) {
    EventTable.getTable().addEvent(eventName, this);
  }
  
  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream)
  {
    String requestVersion = getManager().getScanner().getToken();
    String aToken = getManager().getScanner().getToken();
    if (isFilePath(eventData)) {
      EventTable.getTable().getEvent("serveFile").execute("", new FileWrapper(eventData), aWriteStream);
    } else {
      while ((!aToken.contains("}")) && (!getManager().getScanner().isEmpty())) {
        aToken = getManager().getScanner().getToken();
      }
      String[] brokenPath = eventData.split("/");
      System.out.println("Calling event: " + brokenPath[(brokenPath.length - 1)]);
      EventTable.getTable().getEvent(brokenPath[(brokenPath.length - 1)]).execute(aToken, new FileWrapper(), aWriteStream);
    }
  }
  
  public boolean isFilePath(String aPath)
  {
    return aPath.contains(".");
  }
}