package LIDS.Server.NetworkEvents;

import LIDS.Server.System.Sensor;
import java.io.BufferedOutputStream;
import javax.json.JsonObject;

public class RequestManager
  implements NetworkEvent
{
  private Scanner theScanner = null;
  private BufferedOutputStream responseStream = null;
  
  public RequestManager(Scanner aScanner, BufferedOutputStream aWriteStream) {
    theScanner = aScanner;
    responseStream = aWriteStream;
    aScanner.scan();
  }
  
  public void setScanner(Scanner aMessageScanner) {
    theScanner = aMessageScanner;
  }
  
  public Scanner getScanner() {
    return theScanner;
  }
  
  public void setResponseStream(BufferedOutputStream aResponseStream) {
    responseStream = aResponseStream;
  }
  
  public BufferedOutputStream getResponseStream() {
    return responseStream;
  }
  
  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream)
  {
    String requestType = getScanner().getToken();
    if (!requestType.equals("")) {
      HttpRequestEvent anHttpEvent = (HttpRequestEvent)EventTable.getTable().getEvent(requestType);
      anHttpEvent.setManager(this);
      anHttpEvent.execute(getScanner().getToken(), null, aWriteStream);
    }
  }
  
  public void execute(JsonObject jObject, Sensor aSensor, BufferedOutputStream aBufferedOutputStream) {}
}