package LIDS.Server.NetworkEvents;

import java.io.IOException;
import java.util.Stack;
import java.io.BufferedInputStream;

public class Scanner {
	
	private BufferedInputStream input = null;
	private Stack<String> tokenStack = null;
	
	
	public Scanner(BufferedInputStream aBufferedInputStream){
		input = aBufferedInputStream;
		setTokenStack(new Stack<String>());
		
	}
	
	public Scanner(){
		setTokenStack(new Stack<String>());
	}
	
	public void setInput(BufferedInputStream aBufferedInputStream){
		input = aBufferedInputStream;
	}
	
	public BufferedInputStream getInput(){
		return input;
	}
	
	public Stack<String> getTokenStack(){
		return tokenStack;
	}
	
	public boolean isEmpty(){
		return getTokenStack().isEmpty();
	}
	
	public void setTokenStack(Stack<String> aStringStack){
		tokenStack = aStringStack;
	}
	
	public void scan(){
		String streamResult = "";
		try {// TODO Auto-generated method stub
			byte[] buffer = new byte[4096];
			int bytesRead = this.getInput().read(buffer, 0, 4096);
			while(bytesRead > 0){
				String newBuffer = new String(buffer, "US-ASCII");
				streamResult += newBuffer;
				if(bytesRead == 4096){
					buffer = new byte[200];
					bytesRead = this.getInput().read(buffer, 0, 4096);
				}else{
					break;
				}
				
			}
			System.out.println(streamResult);
				String[] splitBuffer = streamResult.split("\\s");
				for(int i = splitBuffer.length -1; i >= 0; i--){
					getTokenStack().push(splitBuffer[i]);
				}
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Failed to scan the given input: " + streamResult);
		}
	}
	
	public void scanString(String request){
		String[] splitBuffer = request.split("\\s");
		for(int i = splitBuffer.length -1; i >= 0; i--){
			getTokenStack().push(splitBuffer[i]);
		}
	}
	
	public String getToken(){
		if(!this.getTokenStack().isEmpty()){
			return this.getTokenStack().pop();
		}else{
			return "";
		}
	}
}
