package LIDS.Server.NetworkEvents;

import LIDS.Server.System.Sensor;
import LIDS.Server.System.SessionManager;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

public class SensorCountEvent implements NetworkEvent
{
  public SensorCountEvent(String eventName)
  {
    EventTable.getTable().addEvent(eventName, this);
  }
  

  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream)
  {
    JsonObject sessionData = JsonWrapper.createJObject(eventData);
    if (SessionManager.authenticateSession(sessionData.getString("sessionID"), sessionData.getString("sessionUsername"))) {
      JsonObject jObj = JsonWrapper.getObjectBuilder()
        .add("count", String.valueOf(LIDS.Server.System.SensorManager.getSensorCount())).build();
      try {
        aWriteStream.write(jObj.toString().getBytes());
        aWriteStream.flush();
      } catch (IOException ex) {
        ex.printStackTrace();
        System.out.println("failed to write sensor count");
      }
    } else {
      try {
        JsonObject jObj = JsonWrapper.getObjectBuilder()
          .add("count", String.valueOf("-1")).build();
        aWriteStream.write(jObj.toString().getBytes());
        aWriteStream.flush();
      } catch (IOException ex) {
        ex.printStackTrace();
        System.out.println("failed to write sensor count");
      }
    }
  }
  
  public void execute(JsonObject jObject, Sensor aSensor, BufferedOutputStream aBufferedOutputStream) {}
}