package LIDS.Server.NetworkEvents;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.util.ArrayList;

import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

import LIDS.Server.System.Sensor;
import LIDS.Server.System.SensorManager;
import LIDS.Server.System.SessionManager;

public class SensorRelayEvent
  implements NetworkEvent
{
  public SensorRelayEvent(String eventName) {
	  EventTable.getTable().addEvent(eventName, this);
  }
  
  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream) {
	    JsonObject sessionData = JsonWrapper.createJObject(eventData);
	    if (SessionManager.authenticateSession(sessionData.getString("sessionID"), sessionData.getString("sessionUsername"))) {
	    	try {
	    		System.out.println(SensorManager.getSensorList().toString());
		    	for(Sensor eachSensor : SensorManager.getSensorList()){
		    	  aWriteStream.write(eachSensor.toString().getBytes());
		    	}
		    	aWriteStream.flush();
	      } catch (IOException ex) {
	        ex.printStackTrace();
	        System.out.println("failed to write sensor count");
	      }
	    }
  }
  
  public void execute(JsonObject jObject, Sensor aSensor, BufferedOutputStream aBufferedOutputStream) {}
}