package LIDS.Server.NetworkEvents;

import LIDS.Server.System.Sensor;
import LIDS.Server.System.SocketThreadHandler;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;

public class SensorUpdateEvent implements NetworkEvent
{
  public SensorUpdateEvent(String eventName)
  {
    EventTable.getTable().addEvent(eventName, this);
  }
  


  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream) {}
  

  public void execute(JsonObject jObject, Sensor aSensor, BufferedOutputStream aBufferedOutputStream)
  {
    String responseCode = "";
    if ((aSensor.getID() == jObject.getInt("sensorID")) || (!aSensor.getHasIdBeenSet())) {
      aSensor.setArmed(jObject.getInt("armed") != 0);
      aSensor.setAlarmStatus(jObject.getInt("alarmStatus") != 0);
      aSensor.setID(jObject.getInt("sensorID"));
      responseCode = "200";
      SocketThreadHandler.addSensor(aSensor);
    } else {
      LIDS.Server.System.SensorManager.removeMe(aSensor);
      responseCode = "403";
    }
    try {
      aBufferedOutputStream.write(JsonWrapper.getObjectBuilder()
        .add("responseCode", responseCode).build().toString().getBytes());
      System.out.println(responseCode);
      aBufferedOutputStream.flush();
    } catch (IOException ex) {
      ex.printStackTrace();
      SocketThreadHandler.removeMe(aSensor);
    }
    aSensor.lazyNotify();
  }
}