package LIDS.Server.NetworkEvents;

import LIDS.Server.System.Sensor;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import javax.json.JsonObject;

public class ServeFileEvent implements NetworkEvent
{
  public ServeFileEvent(String eventName)
  {
    EventTable.getTable().addEvent(eventName, this);
  }
  
  public void execute(String eventData, FileWrapper aFileNode, BufferedOutputStream aWriteStream)
  {
    BufferedInputStream readStream = null;
    try {
      readStream = new BufferedInputStream(new FileInputStream(aFileNode.getFile()));
    } catch (IOException ex) {
      try {
        readStream = new BufferedInputStream(new FileInputStream(new File("pub/404.html")));
      } catch (IOException exception) {
        System.out.println("Failed to serve the file not found page, public folder may be corrupted");
        exception.printStackTrace();
      }
    }
    byte[] buffer = new byte['က'];
    try {
      int bytesRead = readStream.read(buffer, 0, 4096);
      while (bytesRead > 0) {
        aWriteStream.write(buffer, 0, bytesRead);
        bytesRead = readStream.read(buffer, 0, 4096);
      }
      aWriteStream.flush();
    } catch (IOException ex) {
      ex.printStackTrace();
    }
  }
  
  public void execute(JsonObject jObject, Sensor aSensor, BufferedOutputStream aBufferedOutputStream) {}
}