package LIDS.Server.System;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import java.util.Observable;
import java.util.Observer;

import javax.json.Json;
import javax.json.JsonObject;
import javax.json.JsonReader;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLEngine;
import javax.net.ssl.SSLParameters;
import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.TrustManagerFactory;

import com.sun.net.httpserver.HttpsConfigurator;
import com.sun.net.httpserver.HttpsParameters;
import com.sun.net.httpserver.HttpsServer;

public class HTTPSServerCom extends Observable implements Runnable, Observer{
	private KeyManagerFactory theKeyManagerFactory = null;
	private KeyStore theKeyStore = null;
	private TrustManagerFactory theTrustManagerFactory = null;
	private SSLContext theSSLContext = null;
	private HttpsServer theHttpsServer = null; 
	
	public HTTPSServerCom(){
		theKeyStore = initKeyStore();
		theKeyManagerFactory = initKeyManagerFactory();
		theTrustManagerFactory = initTrustManagerFactory();
		theSSLContext = initSSLContext();
		theHttpsServer = initHttpsServer();
		new Thread(this).start();
		
	}

	public KeyStore initKeyStore(){
		try {
			KeyStore ks = KeyStore.getInstance(KeyStore.getDefaultType());
			char[] password = "N1s8g58s".toCharArray(); //insecure?
			FileInputStream fis = new java.io.FileInputStream("mykeystore.jks");
	        ks.load(fis, password);
		} catch (KeyStoreException e) {
			System.out.println("Failed to initialize the keystore.");
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			System.out.println("File not found");
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (CertificateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		 
		try {
			KeyStore aKeyStore = KeyStore.getInstance("JKS");
			aKeyStore.load((InputStream) new FileInputStream(new File("mykeystore.jks")), "N1s8g58s".toCharArray());
			return aKeyStore;
		} catch (NoSuchAlgorithmException | CertificateException | IOException e) {
			System.out.println("Failed to instantiate the keystore.");
			e.printStackTrace();
		} catch (KeyStoreException e) {
			System.out.println("Failed to initialize the keyStore");
			e.printStackTrace();
		}
		System.exit(1);
		return null;
	}
	
	public KeyManagerFactory initKeyManagerFactory(){
		try {
			KeyManagerFactory aKeyManagerFactory = KeyManagerFactory.getInstance("SUNX509");
			aKeyManagerFactory.init(getKeyStore(), "N1s8g58s".toCharArray());
			return aKeyManagerFactory;
		} catch (KeyStoreException | UnrecoverableKeyException | NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.exit(1);
		return null;
	}
	
	public TrustManagerFactory initTrustManagerFactory(){
		try {
			TrustManagerFactory aTrustManagerFactory = TrustManagerFactory.getInstance("SUNX509");
			aTrustManagerFactory.init(this.getKeyStore());
			return aTrustManagerFactory;
		} catch (NoSuchAlgorithmException | KeyStoreException e) {
			System.out.println("Failed to initialize the TrustManagerFactory");
			e.printStackTrace();
		}
		System.exit(1);
		return null;
	}
	
	public SSLContext initSSLContext(){
		SSLContext anSSLContext;
		try {
			anSSLContext = SSLContext.getInstance("TLS");
			anSSLContext.init(this.getKeyManagerFactory().getKeyManagers(), this.getTrustManagerFactory().getTrustManagers(), null);
			return anSSLContext;
		} catch (NoSuchAlgorithmException | KeyManagementException e) {
			System.out.println("Failed to initialize the SSLContect");
			e.printStackTrace();
		}
		System.exit(1);
		return null;
	}
	
	public HttpsServer initHttpsServer(){
		try {
			HttpsServer anHttpsServer = HttpsServer.create(new InetSocketAddress(InetAddress.getLocalHost(), 7443), 0);
			anHttpsServer.setHttpsConfigurator(new HttpsConfigurator(getSSLContext()) {
		         public void configure(HttpsParameters params) {
		                 try {
		                          // initialise the SSL context
		                          SSLContext c = SSLContext.getDefault();
		                          SSLEngine engine = c.createSSLEngine();
		                          params.setNeedClientAuth(false);
		                          params.setCipherSuites(engine.getEnabledCipherSuites());
		                          params.setProtocols(engine.getEnabledProtocols());
		                          // get the default parameters
		                          SSLParameters defaultSSLParameters = c.getDefaultSSLParameters();
		                          params.setSSLParameters(defaultSSLParameters);
		                 } catch (Exception ex) {
		                          ex.printStackTrace();
		                          System.out.println("Failed to create HTTPS server");
		                 }
		         }
		});
			return anHttpsServer;
		} catch (IOException e) {
			System.out.println("Failed to create Https server instance");
		}
		System.exit(1);
		return null;
	}
	
	public KeyStore getKeyStore(){
		return theKeyStore;
	}
	
	public HttpsServer getHttpsServer(){
		return theHttpsServer;
	}
	
	public SSLContext getSSLContext(){
		return theSSLContext;
		
	}
	
	public KeyManagerFactory getKeyManagerFactory(){
		return theKeyManagerFactory;
	}
	
	public TrustManagerFactory getTrustManagerFactory(){
		return theTrustManagerFactory;
	}
	
	public boolean webLogin(JsonObject aJsonObject){
		return SessionManager.login(aJsonObject.getString("username"), aJsonObject.getString("password"), false);
	}
	public void run(){
		 try{
	            // Create server socket factory
	            SSLServerSocketFactory sslServerSocketFactory = this.getSSLContext().getServerSocketFactory();
	             
	            // Create server socket
	            SSLServerSocket sslServerSocket = (SSLServerSocket) sslServerSocketFactory.createServerSocket(443);
	             
	            System.out.println("SSL server started");
	            while(true){
	                SSLSocket sslSocket = (SSLSocket) sslServerSocket.accept();
	                 
	                // Start the server thread
	                new HTTPSServerThread(sslSocket).start();
	            }
	        } catch (Exception ex){
	            ex.printStackTrace();
	        }
	}
	
	
	
	//public BufferedWriter getWriter(){
	//	return socketWriter;
	//}
	
	//public synchronized boolean writeTo(JsonObject aJsonObject){
	//	
	//}
	
	public void mayIObserve(Observer anObserver){
		addObserver((Observer) anObserver);
		System.out.println(anObserver.getClass().toString().concat("is watching the".concat(this.getClass().toString())));
	}
	
	@Override
	public void update(Observable o, Object arg) {
		//writeTo(localServer.exec(103, null));
	}
	
}
