package LIDS.Server.System;

import java.io.IOException;
import LIDS.Server.Database.DBAccessor;
import LIDS.Server.NetworkEvents.EventTable;
import LIDS.Server.NetworkEvents.JsonWrapper;

public class LIDS implements Runnable{
	private static int DEBUGMODE = 1;
	public static void main(String args[]){
		System.out.println("Working Directory = " +
	              System.getProperty("user.dir"));
		final SocketThreadHandler socketHandler = new SocketThreadHandler();
		HTTPSServerCom theHTTPSServer = new HTTPSServerCom();
		LogHandler.init();
		if(DEBUGMODE == 0){new Thread(new LIDS()).start();}
		Runtime.getRuntime().addShutdownHook(new Thread(){
			public void run(){
				socketHandler.stopListening();
				socketHandler.killConnections();
				//DBAccessor.recordUsers();
				LogHandler.exportToLogFile(SessionManager.getCurrentUser().getName() + " Initiated a System Shutdown");
				LogHandler.destruct();
			}
		});
		EventTable.initializeNetworkTable();
		JsonWrapper.init();
		SensorManager.init();
		SessionManager.init();
		
	}

	@Override
	public void run() {
		Process javaScriptServer = null;
		try {
			System.out.println("Starting js server.");
			String[] commands = {"nodejs", "server.js"};
			javaScriptServer = Runtime.getRuntime().exec(commands);
			System.out.println("Server is alive " + javaScriptServer.isAlive());
		}catch(IOException e){
			System.out.println(System.getProperty("user.dir"));
			System.out.println("Failed To Start JS Server because, " + e.getMessage());
			System.exit(1);
		}
	}
}
