package LIDS.Server.System;


	import java.io.BufferedReader;
	import java.io.BufferedWriter;
	import java.io.IOException;
	import java.net.Socket;

	import java.util.Observable;
	import javax.json.Json;
	import javax.json.JsonBuilderFactory;
	import javax.json.JsonObject;

public class NetworkedModule extends Observable implements Comparable<NetworkedModule>{ //TODO connection is not staying open/ failed to close BufferedReader/
																					//BufferedWriter, this may already be closed DataListener.java:92
		protected static Socket associatedSocket = null;
		protected static BufferedWriter socketWriter = null;
		protected static BufferedReader socketReader = null;
		protected static boolean active = false;
		protected static Thread comThread = null;
		protected int ID = 000;	
		protected JsonBuilderFactory jsonFactory = null;
		
		public NetworkedModule(Socket mySocket, BufferedWriter aWriter, BufferedReader aReader){
			associatedSocket = mySocket;
			socketWriter = aWriter;
			socketReader = aReader;
			jsonFactory = Json.createBuilderFactory(null);
		}
		
		public int getID(){
			return ID;
		}
		
		public BufferedReader getReader(){
			return socketReader;
		}
		
		public BufferedWriter getWriter(){
			return socketWriter;
		}
		
		public Socket getSocket(){
			return associatedSocket;
		}
		
		public void setSocket(Socket aSocket){
			associatedSocket = aSocket;
		}
		
		public String getConnectionType(){
			return (this.getClass().toString().equals("JsServerCom"))? "Web Server" : "Sensor";
		}

		public boolean isActive() {
			return active;
		}

		public void setActive(boolean isActive) {
			active = isActive;
		}

		@Override
		public int compareTo(NetworkedModule aSensor){
			return aSensor.getID() - getID();
		}
		
		public void closeStreams() {
			try {
				associatedSocket.close();
			} catch (IOException e) {
				System.out.println("failed to close socket, socket may already be closed");
			}finally{
				try {
					socketReader.close();
					socketWriter.close();
				} catch (IOException e) {
					System.out.println("failed to close BufferedReader/BufferedWriter, this may already be closed");
				}finally{
					
				}
			}
		}
		
		public void sendModulesToServer(){
			for(Sensor eachSensor : SocketThreadHandler.getSensorList()){
				JsonBuilderFactory factory = Json.createBuilderFactory(null);
				JsonObject value = factory.createObjectBuilder().add("command", 100).add("armed", eachSensor.isArmed()).add("alarmStatus", eachSensor.isAlarmStatus())
						.add("sensorID", eachSensor.getPower()).build();
				try {
					socketWriter.write(value.toString());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					System.out.println("Failed to write to socket");
				}
			}
		}

		public void setID(int iD) {
			ID = iD;
		}

}
