package LIDS.Server.System;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.Provider;
import java.util.Stack;

import LIDS.Server.Exceptions.InvalidUserException;

//TODO add user information fields
public class User {
	private String hashedUserCreds = "-1";
	private String name = "null";
	protected int clearanceLevel = 0;;
	private String number;
	private String sessionID = "";
	
	public boolean equals(User aUser){
		if(this.getHashedUserCreds().equals(aUser.getHashedUserCreds()) 
				&& this.getName().equals(aUser.getName()) 
					&& this.getClearanceLevel() == aUser.getClearanceLevel()){
			return true;
		}
		return false;
	}
	
	public static User createUser(String aUserName, String aPassword, boolean isHashed){
		try{
			return checkEmptyUsername(new User(aUserName, aPassword, isHashed));
		}catch(InvalidUserException ex){
			
		}
		return SessionManager.getNullUser();
	}
	
	protected User(String username, String password, boolean isHashed) {
		setName(username);
		if(isHashed){ setHashedUserCreds(password); return; }
		setHashedUserCreds(hashUserCreds(password));
		number = "";
	}

	public static User checkEmptyUsername(User aUser) throws InvalidUserException{
		if(aUser.getName().equals("")){ throw new InvalidUserException(); }
		return aUser;
	}
	
	public static String hashUserCreds(String password){
		if(password.equals("")){ return "-1"; }
		
		try {
			MessageDigest md5Alg = MessageDigest.getInstance("MD5");
			md5Alg.update( password.getBytes(), 0, password.length());
			return new BigInteger(1, md5Alg.digest()).toString(16);
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			System.out.println("Fatal error occured while attempting to hash the user's credentials");
			System.exit(-1);
		}
		return "-1";
	}
	
	public String getNumber(){
		return number;
	}
	
	public void addNumber(String aNumber){
		number = aNumber;
	}
	
	private void setHashedUserCreds(String password){
		hashedUserCreds = password;
	}
	
	private void setName(String aName) {
		name = aName;
	}

	public String getHashedUserCreds(){
		return hashedUserCreds;
	}
	
	public String getName(){
		return name;
	}
	
	public int getClearanceLevel(){
		return clearanceLevel;
	}
	
	public void setClearanceLevel(int newLevel){
		clearanceLevel = newLevel;
	}
	
	public String toString(){
		return hashedUserCreds + System.lineSeparator() + name + System.lineSeparator() + clearanceLevel ;
	}

	public String getSessionID() {
		return sessionID;
	}

	public void setSessionID(String sessionID) {
		this.sessionID = sessionID;
	}

}
