// ArduinoJson - Version: Latest 
#include <ArduinoJson.h>

// LinkedList - Version: Latest 
#include <LinkedList.h>

#include <WiFi101.h>

#include <string.h>

const int OK = 200;
const int ARMSYSTEM = 201;
const int INVALID_ID = 403;

bool scanAndConnectToBase();
void setID();

int uuid = 000001;
int ind = 1;

String ssid = "test";
String pass = "vvvvvvvv";
byte host[] = {192, 168, 43, 55};
//String host = "www.google.com";
String readBuffer = "";

LinkedList<String>* messageList;

const uint16_t port = 7644;
int sensorID = 8765;

WiFiClient client;

int armed = 0;
volatile int alarmStatus = 0;
bool hasChanged = false;

double power = 100.00;

/*
  Web client

 This sketch connects to a website (http://www.google.com)
 using a WiFi shield.

 This example is written for a network using WPA encryption. For
 WEP or WPA, change the WiFi.begin() call accordingly.

 This example is written for a network using WPA encryption. For
 WEP or WPA, change the WiFi.begin() call accordingly.

 Circuit:
 * WiFi shield attached

 created 13 July 2010
 by dlf (Metodo2 srl)
 modified 31 May 2012
 by Tom Igoe
 */


#include <SPI.h>
#include <WiFi101.h>

void setup() {
  //Initialize serial and wait for port to open:
  Serial.begin(9600);
  analogWrite(A1, 255);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  // check for the presence of the shield:
  if (WiFi.status() == WL_NO_SHIELD) {
    Serial.println("WiFi shield not present");
    // don't continue:
    while (true);
  }

  // attempt to connect to WiFi network:
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print("Attempting to connect to SSID: ");
    Serial.println(ssid);
    // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
    WiFi.begin(ssid, pass);

    // wait 10 seconds for connection:
    delay(10000);
  }
  Serial.println("Connected to wifi");
  printWiFiStatus();
  while(true){
  Serial.println("\nStarting connection to server...");
  // if you get a connection, report back via serial:
  if (client.connect(host, 7644)) {
    Serial.println("connected to server");
    // Make a HTTP request:
    sendUpdate();
    break;
  }
  }
}

void loop() {
  // if there are incoming bytes available
  // from the server, read them and print them:
  String buffer = "";
  while (client.available()) {
    char c = client.read();
    buffer += c;
    Serial.write(c);
  }

  // if the server's disconnected, stop the client:
  if (!client.connected()) {
    Serial.println();
    Serial.println("disconnecting from server.");
    client.stop();

    // do nothing forevermore:
    while (true);
  }
  StaticJsonBuffer<200> jsonBuffer;
  JsonObject& jsnobj = jsonBuffer.parseObject(buffer.c_str());
  int response = jsnobj["responseCode"];
    switch(response){
      case INVALID_ID:
        restart();
        break;
      case ARMSYSTEM:
        armSystem(jsnobj["isArmed"]);
        break;
    }
  
}


void printWiFiStatus() {
  // print the SSID of the network you're attached to:
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());

  // print your WiFi shield's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);

  // print the received signal strength:
  long rssi = WiFi.RSSI();
  Serial.print("signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");
}

bool scanAndConnectToBase(){
    Serial.print("connecting to ");
    //Serial.print(host);
    Serial.print("on port");
    Serial.println(port);
    while(!client.connect(host, port)){
      Serial.println("connection failed");
    }
    Serial.println("connection established");
    return true;
}


void armSystem(bool isArmed){
  Serial.print("The system is Armed : ");
  Serial.println(isArmed);
  if(isArmed){
    armed = 321;
    alarmStatus = 0;
    //updateArmStatus();
    pinMode(7, INPUT);
    attachInterrupt(digitalPinToInterrupt(7), triggered, RISING);
    pinMode(6, OUTPUT);
    digitalWrite(6, HIGH);
   // interrupts();
  }else{
    armed = false;
    detachInterrupt(digitalPinToInterrupt(7));
    //updateArmStatus();
  }
}

void triggered(){
  alarmStatus = 321; 
  hasChanged = true;
}

void sendUpdate(){
  Serial.println("HERE");
  StaticJsonBuffer<200> jsonBuffer;
  String jsnString = "";
  JsonObject& jsnobj = jsonBuffer.createObject();
	jsnobj["command"] = "update";
  jsnobj["armed"] = armed;
  Serial.println("the system is ");
  const char* temp = jsnobj["armed"];
  Serial.println(temp);
  jsnobj["alarmStatus"] = alarmStatus;
  Serial.println("the system is ");
  int temp2 = jsnobj["alarmStatus"];
  Serial.println(temp2);
  jsnobj["power"] = power;
  jsnobj["sensorID"] = sensorID;
  jsnobj.printTo(jsnString);
  client.println(jsnString);
  client.flush();
  Serial.println(jsnString);
  hasChanged = false;
}

void restart(){
  pinMode(2, OUTPUT);
  digitalWrite(2, HIGH);
}

void setID(){
  byte mac[6];
  WiFi.macAddress(mac);
  Serial.println(mac[0]);
  String id = "";
  for(int i = 0; i < 6; i++){
    id += mac[i];
  }
  Serial.println(id);
  sensorID = id.toInt();
}