package LIDS.Server.NetworkEvents;

import java.io.BufferedOutputStream;
import java.io.IOException;

import javax.json.JsonObject;

import LIDS.Server.System.Sensor;
import LIDS.Server.System.SensorManager;
import LIDS.Server.System.SessionManager;
import LIDS.Server.System.SocketThreadHandler;

public class NetworkArmEvent implements NetworkEvent {

	public NetworkArmEvent(String eventName) {
		EventTable.getTable().addEvent(eventName, this);
	}

	@Override
	public void execute(String paramString, FileWrapper paramFileWrapper,
			BufferedOutputStream paramBufferedOutputStream) {
		JsonObject sessionData = JsonWrapper.createJObject(paramString);
	    if (SessionManager.authenticateSession(sessionData.getString("sessionID"), sessionData.getString("sessionUsername"))) {
	    	if(!SensorManager.getSensorList().get(0).isArmed() && SensorManager.getSensorCount() > 0){
	    		SocketThreadHandler.armSystem();
	    	}
	    }
	    try{
	    	paramBufferedOutputStream.write("200 ok".getBytes());
	    	paramBufferedOutputStream.flush();
	    }catch(IOException ex){
	    	ex.printStackTrace();
	    }
	}

	@Override
	public void execute(JsonObject paramJsonObject, Sensor paramSensor,
			BufferedOutputStream paramBufferedOutputStream) {
		// TODO Auto-generated method stub

	}

}
